Index: src/uk/me/parabola/mkgmap/osmstyle/actions/SubstringFilter.java
===================================================================
--- src/uk/me/parabola/mkgmap/osmstyle/actions/SubstringFilter.java	(revision 3376)
+++ src/uk/me/parabola/mkgmap/osmstyle/actions/SubstringFilter.java	(working copy)
@@ -52,12 +52,16 @@
 		} catch (NumberFormatException e) {
 			throw new ExitException(String.format("Numbers not valid in style substring command: '%s'", arg));
 		}
+		if (start > end){
+			throw new ExitException(String.format("start > end in style substring command: '%s'", arg));
+		}
 	}
 
 	protected String doFilter(String value, Element el) {
 		if (value == null) return null;
-
-		if (args == 1) {
+		if (start > value.length())
+			return "";
+		if (args == 1 || end > value.length()) {
 			return value.substring(start);
 		}
 		if (args == 2) {
